#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include "Sensors.h"

int main ()
{
	char *			device_name = "/dev/misc/sensor/w8378xx/0";
	int 			fd;
	SENSORS_MONITOR	sm;
	SENSOR			s;
	int				i;
	
	fd = open(device_name, O_RDWR);
	if ( fd < 0 )
		{
		fprintf(stderr, "open(%s) failed !\n", device_name);
		return false;
		};
		
	if ( ioctl(fd, SENSOR_GET_MONITOR_INFO, &sm, sizeof(sm)) < 0 )
		{
		fprintf(stderr, "ioctl(%s, SENSOR_GET_MONITOR_INFO) failed !\n", device_name );
		return false;
		};
		
	if ( sm.api_version != SENSOR_CURRENT_API_VERSION )
		{
		fprintf(stderr, "%s : incompatible SENSOR version. Sorry.\n", device_name );
		return false;
		};
		
	printf("Monitor : %s\n", sm.name);
						
//	while(true)
//		{
		printf("%d sensors :\n", sm.nb_sensors);
		for (i = 0; i < sm.nb_sensors; i++)
			{
			s.id = i;
			
			if ( ioctl(fd, SENSOR_GET_VALUE, &s, sizeof(s)) >= 0 )
				{
				if ( s.value_divider == 0 )
					printf("%d\t%s\t\tdisabled\n", s.id, s.name);
				else
					{
					float value;
					
					value = s.value;
					value = (value * s.value_multiplier) / s.value_divider;
					printf("%d\t%s\t\t%.2f\n", s.id, s.name, value);
					};
				};
			};

//		snooze(8000000L);
//		};

	close(fd);

	return true;
}